<?php

$type = array
(
	1 => '展示',
	2 => '不展示',
);

$comment = array
(
	1 => '允许评论',
	2 => '不允许评论',
);

$cate = function()
{
	$array = array(-1 => array('name' => '父级栏目'));
	$cate = Dever::load('forum/cate-mainAll');
	if($cate)
	{
		$array += $cate;
	}
	return $array;
};
return array
(
	# 表名
	'name' => 'cate',
	# 显示给用户看的名称
	'lang' => '栏目',
	'order' => 10,
	# 数据结构
	'struct' => array
	(
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '栏目ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
			//'search'	=> 'order',
			'order'		=> 'desc',
			'list'		=> true,
		),
		
		'name'		=> array
		(
			'type' 		=> 'varchar-60',
			'name' 		=> '栏目名称',
			'default' 	=> '',
			'desc' 		=> '请输入栏目名称',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'search'	=> 'fulltext',
			'list'		=> true,
		),
		
		'cate_id'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '上级栏目',
			'default' 	=> Dever::input('option_cate_id', -1),
			'desc' 		=> '请选择上级栏目',
			'match' 	=> 'is_numeric',
			'update'	=> 'select',
			'search'	=> 'order,select',
			//'list'		=> '{cate_id} > 0 ? Dever::load("forum/cate-one#name", {cate_id}) : "父级栏目"',
			'option' 	=> $cate,
		),
		
		'pic'		=> array
		(
			'type' 		=> 'varchar-150',
			'name' 		=> '栏目图片-选填，大小为150X150px',
			'default' 	=> '',
			'desc' 		=> '请选择栏目图片',
			'match' 	=> 'option',
			'update'	=> 'image',
			'key' 		=> '1',
			'place'		=> '150',
		),
		
		'info'		=> array
		(
			'type' 		=> 'varchar-500',
			'name' 		=> '栏目介绍-选填,字数不超过500字，出现栏目头部，如果想清空该介绍，请输入null。',
			'default' 	=> '',
			'desc' 		=> '请输入栏目介绍',
			'match' 	=> 'option',
			'update'	=> 'editor',
		),
		
		'uid'		=> array
		(
			'type' 		=> 'varchar-255',
			'name' 		=> '用户ID-填写此值，代表本栏目下只能由这些用户发表主题，其他人只能阅读和评论。多个用逗号隔开',
			'default' 	=> '',
			'desc' 		=> '请选择用户ID',
			'match' 	=> 'option',
			'update'	=> 'textarea',
		),
		
		'link'		=> array
		(
			'type' 		=> 'varchar-150',
			'name' 		=> '栏目链接-选填,如果填写了链接,则点击本栏目直接跳转至本链接。',
			'default' 	=> '',
			'desc' 		=> '请输入栏目链接',
			'match' 	=> 'option',
			'update'	=> 'text',
		),
		
		'reorder'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '排序(数值越大越靠前)',
			'default' 	=> '1',
			'desc' 		=> '请输入排序',
			'match' 	=> 'option',
			'update'	=> 'text',
			'search'	=> 'order',
			'list_name' => '排序',
			'list'		=> true,
			'order'		=> 'desc',
			'edit'		=> true,
		),
		
		'type'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '是否展示在列表中',
			'default' 	=> '1',
			'desc' 		=> '请选择是否展示在列表中',
			'match' 	=> 'is_numeric',
			'option' 	=> $type,
			'update'	=> 'radio',
			'list'		=> true,
			'edit'		=> true,
		),
		
		'comment'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '是否允许评论',
			'default' 	=> '1',
			'desc' 		=> '请选择是否允许评论',
			'match' 	=> 'is_numeric',
			'option' 	=> $comment,
			'update'	=> 'radio',
			'list'		=> true,
			'edit'		=> true,
		),

		'state'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '状态',
			'default' 	=> '1',
			'desc' 		=> '请选择状态',
			'match' 	=> 'is_numeric',
		),
		
		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '录入时间',
			'match' 	=> array('is_numeric', time()),
			'desc' 		=> '',
			# 只有insert时才生效
			'insert'	=> true,
			'list'		=> 'date("Y-m-d H:i:s", {cdate})',
		),
	),
	
	'manage' => array
	(
		# 列表页的类型
		'list_type' => 'parent',

		'list_button' => array
		(
			'add' => array('新增子栏目', '"cate&option_cate_id={id}"', '{cate_id}<=0'),
			//6 => '删除'
		),
	),
	
	# request 请求接口定义
	'request' => array
	(
		# info 取一条正常的数据
		'info' => array
		(
			'where' => array
			(
				'id' => 'is_numeric',
				'state' => 1,
			),
			'type' => 'one',
		),
		
		'link' => array
		(
			'where' => array
			(
				'link' => 'is_string',
				'state' => 1,
			),
			'type' => 'one',
		),
		
		# main 取所有主栏目
		'main' => array
		(
			'where' => array
			(
				'cate_id' => -1,
				'state' => 1,
				'type' => 1,
			),
			'type' => 'all',
			'order' => array('reorder` desc,`id', 'desc'),
			'col' => '*|id',
		),
		
		# 取所有下级栏目
		'child' => array
		(
			'where' => array
			(
				'cate_id' => array('1', '>='),
				'state' => 1,
				'type' => 1,
			),
			'type' => 'all',
			'order' => array('reorder` desc,`id', 'desc'),
			'col' => '*|cate_id|id|',
		),
		
		
		# main 取所有主栏目
		'mainAll' => array
		(
			'where' => array
			(
				'cate_id' => -1,
				'state' => 1,
			),
			'type' => 'all',
			'order' => array('reorder` desc,`id', 'desc'),
			'col' => '*|id',
		),
		
		# 取所有下级栏目
		'childAll' => array
		(
			'where' => array
			(
				'cate_id' => array('1', '>='),
				'state' => 1,
			),
			'type' => 'all',
			'order' => array('reorder` desc,`id', 'desc'),
			'col' => '*|cate_id|id|',
		),
	),
);
