<?php

$comment = array
(
	1 => '评论需要登录',
	2 => '评论不需要登录',
);

return array
(
	# 表名
	'name' => 'config',
	# 显示给用户看的名称
	'lang' => '站点信息配置',
	'order' => 10,
	# 数据结构
	'struct' => array
	(
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '网站ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
		),
		
		'hr1'		=> array
		(
			'name' 		=> '基本信息',
			'class'		=> '',//本项必须填写
			'attr'		=> '',
		),
		
		
		'name'		=> array
		(
			'type' 		=> 'varchar-32',
			'name' 		=> '网站名称',
			'default' 	=> '',
			'desc' 		=> '请输入网站名称',
			'match' 	=> 'is_string',
			'update'	=> 'text',
		),
		
		'logo'		=> array
		(
			'type' 		=> 'varchar-150',
			'name' 		=> '网站logo-200X200',
			'default' 	=> '',
			'desc' 		=> '请选择网站logo',
			'match' 	=> 'is_string',
			//'update'	=> 'image',
			'key' 		=> '1',
			'place'		=> '160X160',
		),
		
		'info'		=> array
		(
			'type' 		=> 'text-255',
			'name' 		=> '网站介绍',
			'default' 	=> '',
			'desc' 		=> '请输入网站介绍',
			'match' 	=> 'option',
			'update'	=> 'textarea',
		),
		
		'hr2'		=> array
		(
			'name' 		=> 'SEO信息',
			'class'		=> '',//本项必须填写
			'attr'		=> '',
		),
		
		'title'		=> array
		(
			'type' 		=> 'varchar-50',
			'name' 		=> '网站title',
			'default' 	=> '',
			'desc' 		=> '请输入网站标题',
			'match' 	=> 'is_string',
			'update'	=> 'text',
		),

		'keyword'		=> array
		(
			'type' 		=> 'varchar-50',
			'name' 		=> '网站keyword',
			'default' 	=> '',
			'desc' 		=> '请输入网站关键词',
			'match' 	=> 'is_string',
			'update'	=> 'text',
		),
		'description'		=> array
		(
			'type' 		=> 'varchar-150',
			'name' 		=> '网站description',
			'default' 	=> '',
			'desc' 		=> '请输入网站描述',
			'match' 	=> 'is_string',
			'update'	=> 'textarea',
		),
		
		'hr3'		=> array
		(
			'name' 		=> '版权与介绍',
			'class'		=> '',//本项必须填写
			'attr'		=> '',
		),
		
		'copyright'		=> array
		(
			'type' 		=> 'varchar-200',
			'name' 		=> '版权信息',
			'default' 	=> '',
			'desc' 		=> '请输入版权信息',
			'match' 	=> 'is_string',
			'update'	=> 'textarea',
		),
		
		'icp'		=> array
		(
			'type' 		=> 'varchar-200',
			'name' 		=> 'icp备案信息-填写别的信息也可以的',
			'default' 	=> '',
			'desc' 		=> '请输入icp备案信息',
			'match' 	=> 'is_string',
			'update'	=> 'textarea',
		),
		
		'code'		=> array
		(
			'type' 		=> 'text-255',
			'name' 		=> '尾部代码-一般用于填写统计代码',
			'default' 	=> '',
			'desc' 		=> '请输入尾部代码',
			'match' 	=> 'option',
			'update'	=> 'textarea',
		),
		
		'notice'		=> array
		(
			'type' 		=> 'text-255',
			'name' 		=> '头部公告',
			'default' 	=> '',
			'desc' 		=> '请输入头部公告',
			'match' 	=> 'option',
			'update'	=> 'editor',
		),

		'hr4'		=> array
		(
			'name' 		=> '其他配置',
			'class'		=> '',//本项必须填写
			'attr'		=> '',
		),

		'catename'		=> array
		(
			'type' 		=> 'varchar-255',
			'name' 		=> '版块名称-用于定义发布页面中的"请选择XXXX"中的"XXXX"',
			'default' 	=> '',
			'desc' 		=> '请输入版块名称',
			'match' 	=> 'is_string',
			'update'	=> 'text',
		),
		
		'comment'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '评论用户是否登录开关',
			'default' 	=> '1',
			'desc' 		=> '请选择评论用户是否登录开关',
			'match' 	=> 'option',
			'option' 	=> $comment,
			'update'	=> 'radio',
		),
		
		'noname'		=> array
		(
			'type' 		=> 'varchar-50',
			'name' 		=> '前台匿名用户的称谓-默认为"匿名用户"',
			'default' 	=> '匿名用户',
			'desc' 		=> '请输入前台匿名用户的称谓',
			'match' 	=> 'option',
			'update'	=> 'text',
		),

		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '录入时间',
			'match' 	=> array('is_numeric', time()),
			'desc' 		=> '',
			# 只有insert时才生效
			'insert'	=> true,
		),
	),

	'default' => array
	(
		'col' => 'name,info,title,keyword,description,copyright,icp,catename,noname,cdate',
		'value' => array
		(
			'"Dever Plant","Dever Plant是由Dever构建，一个小型的开源社区系统","Dever Plant","Dever,PHP,Framework,PHP论坛,PHP社区,框架,MVC","Dever Plant","Made With By Dever Plant","京ICP备15006344号","版块","匿名用户",' . time(),
		),
	),

	'manage' => array
	(
		# 后台管理不要列表页
		'list' => 'update',
	),
);
