<?php

$time = time();

return array
(
	# 表名
	'name' => 'page',
	# 显示给用户看的名称
	'lang' => '页面管理',
	# 后台菜单排序
	'order' => 7,
	# 数据结构
	'struct' => array
	(
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '页面ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
			'search'	=> 'order',
			//'list'		=> true,
			'order'		=> 'desc',
		),
		
		'name'		=> array
		(
			'type' 		=> 'varchar-32',
			'name' 		=> '页面名称',
			'default' 	=> '',
			'desc' 		=> '请输入页面名称',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'search'	=> 'order,fulltext',
			'list'		=> '"<a href=\"".Dever::load("main/data.page", {id})."\" target=\"_blank\">{name}</a>"',
		),

		'state'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '状态',
			'default' 	=> '1',
			'desc' 		=> '请选择状态',
			'match' 	=> 'is_numeric',
		),
		
		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '录入时间',
			'match' 	=> array('is_numeric', $time),
			'desc' 		=> '',
			# 只有insert时才生效
			'insert'	=> true,
			'list'		=> 'date("Y-m-d H:i:s", {cdate})',
		),
	),

	'manage' => array
	(
		'list_button' => array
		(
			//oper_save_jump=system&oper_parent=system 特殊配置 oper_save_jump保存之后跳到那个表的列表页  oper_parent下级列表页中显示返回上一页的链接
			'add' => array('新增模块', '"model&project=forum&search_option_page={id}&oper_parent=page&oper_project=main"'),
			'list' => array('模块列表', '"model&project=forum&search_option_page={id}&oper_parent=page&oper_project=main"'),
		),
	),

	# 默认值
	'default' => array
	(
		'col' => 'id,name,state,cdate',
		'value' => array
		(
			'1,"首页",1,' . $time,
			'2,"列表页",1,' . $time,
			'3,"底层页",1,' . $time,
			'4,"发布页",1,' . $time,
			'5,"关于我",1,' . $time,
		),
	),
);
